## frama-c 20151002+magnesium+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2015                                               #
#    CEA (Commissariat à l'énergie atomique et aux énergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common
include share/Makefile.dynamic_config.internal

#Check share/Makefile.config available
ifndef FRAMAC_TOP_SRCDIR
$(error "You should run ./configure first (or autoconf if there is no configure)")
endif

###################
# Frama-C Version #
###################

VERSION:=$(shell $(SED) -e 's/\(\.*\)/\1/' VERSION)
VERSION_PREFIX = $(shell $(SED) -e 's/\([a-zA-Z]\+-[0-9]\+\).*/\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_GUI_LIB_DIR= $(PLUGIN_LIB_DIR)/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_GENERATED_LIST:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_META_LIST :=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

CEA_WP:=
UNMODIFIED_WHY3:=
MODIFIED_WHY3:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
# Remove -I +.* and -I C:/absolute/win/path
INCLUDES_FOR_OCAMLDEP=$(addprefix -I , $(FRAMAC_SRC_DIRS)) \
                      -I $(PLUGIN_LIB_DIR) -I lib

# Ocamldep flags
DEP_FLAGS= $(shell echo $(INCLUDES_FOR_OCAMLDEP) \
             | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g")

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(FRAMAC_SRC_DIRS)) \
		$(addsuffix /*.ml, $(FRAMAC_SRC_DIRS))

# Developments flags to be used by ocamlc and ocamlopt when compiling Frama-C
# itself. For development versions, we add -warn-error for most warnings
# (or all if WARN_ERROR_ALL is set). -warn-error has effect only for warnings
# that are explicitely set using '-w'. For Frama-C, this is done in
# share/Makefile.common, as active warnings are inherited by plugins.
ifeq ($(DEVELOPMENT),yes)
ifeq ($(WARN_ERROR_ALL),yes) # To be set on the command-line
DEV_WARNINGS= -warn-error +a
else
DEV_WARNINGS= -warn-error +a-32-33-34-35-36-37-38-39
endif #WARN_ERROR_ALL
DEV_FLAGS=$(FLAGS) $(DEV_WARNINGS)
else
DEV_FLAGS=$(FLAGS)
endif #DEVELOPMENT

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(OUNIT_COMPILER_BYTE) \
		$(FRAMAC_USER_FLAGS)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(OUNIT_COMPILER_OPT) -compact \
		$(FRAMAC_USER_FLAGS)

BLINKFLAGS += $(BFLAGS) -linkall -custom
OLINKFLAGS += $(OFLAGS) -linkall

DOC_FLAGS= -colorize-code -stars -m A -hide-warnings $(INCLUDES) $(GUI_INCLUDES)

ifeq ($(HAS_OCAML402),yes)
	DOC_FLAGS += -w -3
endif

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
INCLUDE_FINDLIB:=$(shell ocamlfind query -i-format findlib)
INCLUDES+= $(INCLUDE_FINDLIB)
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma findlib.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa findlib.cmxa \
	$(EXTRA_OPT_LIBS)

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/, \
		frama-c.ico frama-c.gif unmark.png )

FEEDBACK_ICONS_NAMES:= \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		switch-on.png \
		switch-off.png

FEEDBACK_ICONS_DEFAULT:= \
	$(addprefix share/theme/default/, $(FEEDBACK_ICONS_NAMES))
FEEDBACK_ICONS_COLORBLIND:= \
	$(addprefix share/theme/colorblind/, $(FEEDBACK_ICONS_NAMES))

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= sys netinet linux net arpa
LIBC_DIR:= $(ROOT_LIBC_DIR) $(addprefix $(ROOT_LIBC_DIR)/, $(LIBC_SUBDIRS))
FREE_LIBC:= \
	share/*.h share/*.c \
	$(addsuffix /*.h, $(LIBC_DIR)) \
	$(ROOT_LIBC_DIR)/__fc_builtin_for_normalization.i

NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))


# Checks that all .h can be included multiple times.
ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h, $(LIBC_DIR)))

check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
	@echo "checking libc..."; \
	 EXIT_VALUE=0; \
	 for file in $(ALL_LIBC_HEADERS); do \
	   echo "#include \"$$file\"" > check-libc.c; \
	   echo "#include \"$$file\"" >> check-libc.c; \
	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
           -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
               > $$(basename $$file .h).log 2>&1; \
	   if test $$? -ne 0; then \
	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
	     else \
	       echo "$$file cannot be included twice. \
Output is in $$(basename $$file .h).log"; \
	       EXIT_VALUE=1; \
	     fi; \
	   else \
	     rm $$(basename $$file .h).log; \
           fi; \
	 done; \
	 rm check-libc.c; \
	 exit $$EXIT_VALUE

clean-check-libc:
	$(RM) *.log

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=\
      bin/*2*.sh							\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(FEEDBACK_ICONS_DEFAULT) $(FEEDBACK_ICONS_COLORBLIND)	\
      man/frama-c.1 doc/README			\
      doc/code/docgen_*.ml						\
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
      doc/code/intro_wp.txt doc/code/toc_head.htm			\
      doc/code/toc_tail.htm                                             \
      $(filter-out                                                      \
         $(addprefix doc/code/print_api/,                              \
               dynamic_plugins.mli grammar.ml grammar.mli lexer.ml),    \
         $(wildcard doc/code/print_api/*.ml*))                          \
      doc/code/print_api/Makefile                                       \
      doc/Makefile                                                      \
      $(filter-out ptests/ptests_config.ml, $(wildcard ptests/*.ml*))   \
      configure.in Makefile Makefile.generating 			\
      Changelog config.h.in	\
      VERSION licenses/* 						\
      $(FREE_LIBC)                                                      \
      share/acsl.el share/configure.ac					\
      share/Makefile.config.in share/Makefile.common                    \
      share/Makefile.generic			                        \
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal		   		\
      $(filter-out src/kernel_internals/runtime/config.ml,              \
	  $(wildcard src/kernel_internals/runtime/*.ml*))               \
      src/kernel_services/abstract_interp/*.ml*                         \
      src/plugins/gui/*.ml*                                             \
      $(filter-out src/libraries/stdlib/integer.ml                      \
	src/libraries/stdlib/FCDnlink.ml,                               \
        $(wildcard src/libraries/stdlib/*.ml*))                         \
      $(wildcard src/libraries/utils/*.ml*)                             \
      src/libraries/utils/*.c                                           \
      src/libraries/project/*.ml*                                       \
      $(filter-out src/kernel_internals/parsing/check_logic_parser.ml, \
	  src/kernel_internals/parsing/*.ml*)                          \
      src/kernel_internals/typing/*.ml*                               \
      src/kernel_services/ast_data/*.ml*                                \
      src/kernel_services/ast_queries/*.ml*                          \
      src/kernel_services/ast_printing/*.ml*                            \
      src/kernel_services/cmdline_parameters/*.ml*                      \
      src/kernel_services/analysis/*.ml*                                \
      src/kernel_services/ast_transformations/*.ml*                                 \
      src/kernel_services/plugin_entry_points/*.ml*                     \
      src/kernel_services/visitors/*.ml*                                \
      src/kernel_services/parsetree/*.ml*                                    \
      src/libraries/datatype/*.ml*                                      \
      bin/sed_get_make_major bin/sed_get_make_minor                     \
      INSTALL INSTALL_WITH_WHY .make-clean	                        \
      .make-clean-stamp .make-ocamlgraph-stamp .force-reconfigure 	\
      opam/* opam/files/*
