=== debian/changelog ===
frama-c (20151002+magnesium+dfsg-1build1) xenial; urgency=medium

  * Rebuild for new GHC ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Feb 2016 11:58:13 +0100

frama-c (20151002+magnesium+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Refresh patches.
    - Add ocaml-findlib and libfindlib-ocaml-dev to Build-Depends
      since they became a hard requirement.
  * Fix variable FRAMA_GUI_LIBS in debian/rules: "gui" directory
    moved from "src" to "src/plugins".
  * Fix ocaml-dangling-cmx and ocaml-dangling-cmxa.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 24 Jan 2016 00:33:56 +0100
